#!/usr/bin/python
# -*- coding: utf-8 -*-

###  
###  libnss-mysql-bg-gui 0.1.0
###  
###  GUI for libnss-mysql-bg
###  
###  (c) Pavel Zaytsev
###  Licence: GPL
###  Homesite: http://www.avist.biz
###  



import sys
import md5crypt
from PyQt4 import QtCore, QtGui, QtSql, Qt
from PyQt4.QtCore import *
from ui_users import Ui_UsersDialog
from ui_userdialog import Ui_UserDialog
from ui_connection import Ui_ConnectionDialog


version = "0.1.0";
connectedToDatabase=False;


class UsersDialog(QtGui.QDialog, Ui_UsersDialog):
	def __init__(self):
		QtGui.QDialog.__init__(self)
		self.setupUi(self)
		self.setWindowTitle("GUI for libnss-mysql-bg")
		self.setButtonsEnabled(False)
		self.connect(self.addButton, QtCore.SIGNAL("clicked()"), self.userAdd )
		self.connect(self.delButton, QtCore.SIGNAL("clicked()"), self.userDel )
		self.connect(self.editButton, QtCore.SIGNAL("clicked()"), self.userEdit )
		self.connect(self.aboutButton, QtCore.SIGNAL("clicked()"), self.about )
		self.connect(self.configureButton, QtCore.SIGNAL("clicked()"), self.about)
		self.connect(self.connectButton, QtCore.SIGNAL("clicked()"), self.connectClicked)
		self.connect(self.tableUsers, QtCore.SIGNAL("activated(QModelIndex)"), self.userEdit);

	def initData(self):
		self.model = QtSql.QSqlTableModel(self);
		self.model.setTable("users");
		self.model.setEditStrategy(QtSql.QSqlTableModel.OnManualSubmit)
		self.model.select()
		self.tableUsers.setModel(self.model)
		self.tableUsers.setAlternatingRowColors(True);
		self.tableUsers.setSortingEnabled(True)
		self.tableUsers.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows);
		self.tableUsers.setEditTriggers(QtGui.QAbstractItemView.NoEditTriggers);
		
	        self.model.setHeaderData(self.model.fieldIndex("username"), Qt.Horizontal, QVariant("Login"));
		self.model.setHeaderData(self.model.fieldIndex("gecos"), Qt.Horizontal, QVariant("Name"));
		self.model.setHeaderData(self.model.fieldIndex("homedir"), Qt.Horizontal, QVariant("Home Directory"));
		self.model.setHeaderData(self.model.fieldIndex("shell"), Qt.Horizontal, QVariant("Shell"));
		self.model.setHeaderData(self.model.fieldIndex("inact"), Qt.Horizontal, QVariant("Blocked"));
		
		self.tableUsers.hideColumn(self.model.fieldIndex("uid"))
		self.tableUsers.hideColumn(self.model.fieldIndex("gid"))
		self.tableUsers.hideColumn(self.model.fieldIndex("password"))
		self.tableUsers.hideColumn(self.model.fieldIndex("lstchg"))
		self.tableUsers.hideColumn(self.model.fieldIndex("min"))
		self.tableUsers.hideColumn(self.model.fieldIndex("max"))
		self.tableUsers.hideColumn(self.model.fieldIndex("expire"))
		self.tableUsers.hideColumn(self.model.fieldIndex("flag"))
		self.tableUsers.hideColumn(self.model.fieldIndex("warn"))
	
	def userAdd(self):
		ud=UserDialog()
		self.reselectUsersTable()
		#ud.exec_()
		
	def userEdit(self):
		i=self.model.record(self.tableUsers.currentIndex().row()).value("uid").toInt()
		if(i[0]!=0):
			ud=UserDialog(i[0])
		else:
			mb=QtGui.QMessageBox.critical(self, "Error", "Please select user first");
		self.reselectUsersTable()

	def userDel(self):
		i=self.model.record(self.tableUsers.currentIndex().row()).value("uid").toInt()
		if(i[0]!=0):
			DeleteUser(self, (i[0]))
		else:
			mb=QtGui.QMessageBox.critical(self, "Error", "Please select user first");
		self.reselectUsersTable()
	
	def reselectUsersTable(self):
		self.model.select()
		
	def connectClicked(self):
		db = QtSql.QSqlDatabase.database("qt_sql_default_connection")
		if (self.addButton.isEnabled() == True):
			self.tableUsers.model().clear()
			closeConnection()
			self.connectButton.setChecked(False);
			self.setButtonsEnabled(False)
		else:
			ConnectionDialog()
			db = QtSql.QSqlDatabase.database()
			if (db.isOpen()== True):
				self.initData();
				self.connectButton.setChecked(True);
				self.setButtonsEnabled(True)
			else:
				self.connectButton.setChecked(False);
	
	def setButtonsEnabled(self, state):
			self.addButton.setEnabled(state)
			self.editButton.setEnabled(state)
			self.delButton.setEnabled(state)
		
		
		
	def about(self):
		mb=QtGui.QMessageBox.about(self, "About this programm", "This is GUI for <a href=\"http://libnss-mysql.sourceforge.net/\">libnss-mysql-bg</a> users database<br /><br /> Author: Pavel Zaytsev <a href=\"mailto:info@avist.biz\">info@avist.biz</a><br />Avist Software <a href=\"http://www.avist.biz\">http://www.avist.biz</a> <br /> License: GPL <br /><br />Version: "+version+"<br /><br />(c) 2008, Pavel Zaytsev<br>(c) 2008, Avist Software" );
		



class UserDialog(QtGui.QDialog, Ui_UserDialog):
	def __init__(self, uid=0):
		QtGui.QDialog.__init__(self)
		self.setupUi(self)
		self.setWindowTitle("User")
		if( uid == 0):
			print "Open InserNewUser Dialog"
		else:
	     		query=QtSql.QSqlQuery(QtCore.QString("SELECT * FROM users WHERE uid=%1").arg(uid));
     			while (query.next()):
         			self.lineLogin.setText(query.value(query.record().indexOf("username")).toString());
         			self.lineName.setText(query.value(query.record().indexOf("gecos")).toString());
         			self.lineHomedir.setText(query.value(query.record().indexOf("homedir")).toString());
         			self.lineShell.setText(query.value(query.record().indexOf("shell")).toString());
	 			self.checkInActive.setChecked(query.value(query.record().indexOf("inact")).toBool());
		
		if( self.exec_() == 1 ):
			if( uid == 0): 
				InserNewUser(self, self.lineLogin.text(), self.lineName.text(), self.linePassword.text(), self.lineHomedir.text(), self.lineShell.text(), self.checkInActive.isChecked())
				print "User added"
			else:
				UpdateUser(self, uid, self.lineLogin.text(), self.lineName.text(), self.linePassword.text(), self.lineHomedir.text(), self.lineShell.text(), self.checkInActive.isChecked())
		

class ConnectionDialog(QtGui.QDialog, Ui_ConnectionDialog):
	def __init__(self, test=0):
		QtGui.QDialog.__init__(self)
		self.setupUi(self)
		if( test == 0):
			print "testmode"
		
		if( self.exec_() == 1 ):
			if(createConnection(self.lineHostName.text(), self.lineDatabaseName.text(), self.linePort.text(), self.lineLogin.text(), self.linePassword.text())==True):
				connectedToDatabase=True;
			else:
				mb=QtGui.QMessageBox.critical(self, "Error", "Can`t connect to databse!");


def createConnection(hostname, database, port, username, password, driver="QMYSQL"):
    db = QtSql.QSqlDatabase.addDatabase(driver);
    db.setHostName(hostname);
    db.setDatabaseName(database);
    db.setPort(int(port));
    db.setUserName(username);
    db.setPassword(password);
    ok = db.open();
    return ok;

def closeConnection():
	#db = QtSql.QSqlDatabase.database("qt_sql_default_connection")
	#db.close()
	QtSql.QSqlDatabase.removeDatabase("qt_sql_default_connection")
	print "Connection to DB closed"
	return True


def InserNewUser(self, username, gecos, password, homedir, shell, inactive):
     query=QtSql.QSqlQuery();
     q="INSERT INTO users (username, gecos, password, homedir, shell, inact) VALUES ('"+username+"', '"+gecos+"',  ENCRYPT('"+cryptPassword(password)+"'), '"+homedir+"', '"+shell+"', '"+str(int(inactive))+"')"
     if(query.exec_(q) == False):
	mb=QtGui.QMessageBox.critical(self, "Error", "Can`t add user!");
     print username;

def UpdateUser(self, uid, username, gecos, password, homedir, shell, inactive):
     query=QtSql.QSqlQuery();
     q="UPDATE `auth`.`users` SET `username` = '"+username+"', `gecos` = '"+gecos+"' , `shell` = '"+shell+"', `homedir` = '"+homedir+"', `inact` = '"+str(int(inactive))+"' "
     if(password != ""):
     	q+=", `password` = ENCRYPT('"+cryptPassword(password)+"') "
     q+="WHERE `users`.`uid` = '"+str(uid)+"' LIMIT 1"
     if(query.exec_(q) == False):
	mb=QtGui.QMessageBox.critical(self, "Error", "Can`t update user!");

def DeleteUser(self, uid):
     query=QtSql.QSqlQuery();
     q="DELETE FROM `users` "
     q+="WHERE `users`.`uid` = '"+str(uid)+"' LIMIT 1"
     if(query.exec_(q) == False):
	mb=QtGui.QMessageBox.critical(self, "Error", "Can`t delete user!");


def cryptPassword(password):
	# if use UNIX CRYP uncomment this
	#salt="m5a0RvUn"
	#cryptedpassword = md5crypt.md5crypt(password, salt);
	cryptedpassword=password
	return cryptedpassword



if __name__=="__main__":
    #createConnection()
    app = QtGui.QApplication(sys.argv)
    aw = UsersDialog()
    aw.show()
    sys.exit(app.exec_())
